#ifndef __container_h
#define __container_h
#pragma interface
#include "canvas.h"

class ContainerComponent: public Canvas {
  Array<Component *> components;
protected:
  int curfocus;
public:
  ContainerComponent();
  int countComponents() const { return components.size(); }
  Component *getComponent(int i) const { return components[i]; }
  Component *locate(int x,int y) const;
  void add(Component *);
  int indexOf(Controller *);
  void remove(Component *);
  void removeAll();
  void paint(DrawingContext *dc);
  void remoteMethod(int cmd);
  void setfocus(Controller *);
  void setTab(Controller *);
  Component *getTab();
  virtual class FrameComponent *getFrame() const;
  virtual ContainerComponent * obscured();
  void getfocus();
  void losefocus();
  void nextFocus();
  void prevFocus();
  bool focusForward();
  bool focusBackward();
  ~ContainerComponent();
};
#endif
