#pragma interface
#include "remotepeer.h"

struct RemoteComponent: RemotePeer {
  RemoteComponent(class Component *);
  virtual void remoteMethod(int cmd);
  ~RemoteComponent();
protected:
  class Component *comp;
};

struct RemoteContainer: RemoteComponent {
  RemoteContainer(class ContainerComponent *);
  virtual void remoteMethod(int cmd);
  ~RemoteContainer();
};

struct RemoteWindow: RemoteContainer {
  RemoteWindow(class WindowComponent *);
  virtual void remoteMethod(int cmd);
  ~RemoteWindow();
};

struct RemoteDialog: RemoteWindow {
  RemoteDialog(class Dialog *);
  virtual void remoteMethod(int cmd);
  ~RemoteDialog();
};

struct RemoteFrame: RemoteDialog {
  RemoteFrame(class FrameComponent *);
  virtual void remoteMethod(int cmd);
  ~RemoteFrame();
};

struct RemoteLabel: RemoteComponent {
  RemoteLabel(class LabelComponent *);
  virtual void remoteMethod(int cmd);
  ~RemoteLabel();
};

struct RemoteButton: RemoteLabel {
  RemoteButton(class Button *);
  ~RemoteButton();
};

struct RemoteCheckbox: RemoteButton {
  RemoteCheckbox(class CheckBox *);
  virtual void remoteMethod(int cmd);
  ~RemoteCheckbox();
};

struct RemoteTextComponent: RemoteComponent {
  RemoteTextComponent(class TextComponent *);
  virtual void remoteMethod(int cmd);
  ~RemoteTextComponent();
};

struct RemoteTextField: RemoteTextComponent {
  RemoteTextField(class TextField *);
  virtual void remoteMethod(int cmd);
  ~RemoteTextField();
};

struct RemoteTextArea: RemoteTextComponent {
  RemoteTextArea(class TextArea *);
  virtual void remoteMethod(int cmd);
  ~RemoteTextArea();
};
