#ifndef __textedit_h
#define __textedit_h
#pragma interface
#include "textbrowse.h"
#include <strlist.h>
#include <textlist.h>

struct TextEdit: EditorBase, TextBrowse {
  TextEdit(StringList *model = 0);
  ~TextEdit();
  void key(int);
  void cmd(int);
  void addch(char);
  void insch(char);
  void delch();
  void insertln(int);
  void deleteln(int);
  void clrtoeol();
  void replaceText(const String &txt);
  void replaceText(const String &txt,int start,int end);
  //void restoreLine();	// undo changes to current line
  void reform(bool = false);
  static String pasteBuffer;
private:
  void repaintToEOL(int row,int col);
  void repaintToEOL();
  struct TextList: TextArray {
    StringList &txt;
    const char *operator[](int i) {
      if (i < 0 || i >= txt.size()) return 0;
      return txt[i].chars();
    }
    int size() { return txt.size(); }
    TextList(StringList &r): txt(r) { }
  };
  TextList view;
  TextEdit(const TextEdit &);
  TextEdit&operator=(const TextEdit &);
protected:
  StringList &txt;
  int wrapmargin;
};
#endif
