#pragma interface

class TextSelection {
  int row;
  int col;
  int markrow;
  int markcol;
  bool isgap;
  static int cmpCursor(int r1, int c1, int r2, int c2) {
    return (r1 == r2) ? c1 - c2 : r1 - r2;
  }
protected:
  class TextArray &txt;
public:
  TextSelection(class TextArray &);
  class String getSelectedText() const;
  int getRow() const { return row; }
  int getCol() const { return col; }
  int getStartRow() const;
  int getEndRow() const;
  int getStartCol() const;
  int getEndCol() const;
  long getPos(int row,int col) const;
  long getStart() const;
  long getEnd() const;
  void setCursor(int row,int col);
  void setPos(long pos);
  void select(long start, long end);
  void mark();			// set mark = cursor
  virtual void selectionChanged(int orow,int ocol,int nrow,int ncol) = 0;
  bool isReversed() const;
  /* If rowSelected() returns false, isSelected() will always return false.
     If rowSelected() returns true, isSelected() may return true or false.
   */
  bool rowSelected(int row) const;
  bool isSelected(int row,int col) const;
  bool isGap() const;
};
