#pragma interface
#include "container.h"

class FrameComponent;

struct WindowComponent: ContainerComponent {
  WindowComponent(FrameComponent *);
  ~WindowComponent();
  IndirectContext *getDC();
  void repaint(const Rect &);
  void show(bool);
  void remoteMethod(int cmd);
  void reshape(int x,int y,int w,int h);
  void setCursor(int x,int y);
  void setCursor(int type);
  void setfocus(Controller *);
  void nextFocus();
  void prevFocus();
  bool nextFocus(Component *);
  bool prevFocus(Component *);
  void getfocus();
  void losefocus();
  void key(int k);
  class FrameComponent *getFrame() const;
protected:
  class WindowContext *win;
  WindowComponent *owner;
private:
  WindowComponent(const WindowComponent &);
};

class Dialog: public WindowComponent {
  Dialog(const Dialog &);
  String title;
  bool sizable;
public:
  Dialog(FrameComponent *);
  const char *getTitle() const { return title; }
  void remoteMethod(int cmd);
  void setTitle(const String &);
  void key(int k);
  void show(bool);
  IndirectContext *getDC();
  void repaint(const Rect &);
  void setCursor(int x,int y);
  ~Dialog();
};

class FrameComponent: public Dialog {
  FrameComponent(const FrameComponent &);
  MenuContainer *menu;
public:
  FrameComponent();
  void remoteMethod(int cmd);
  void setMenu(MenuContainer *m);
  void key(int k);
  class FrameComponent *getFrame() const;
  ~FrameComponent();
};
